
do

	_detalhes.DeathGraphsWindowBuilder = function (DeathGraphs)

		local f = DeathGraphs.Frame
		
		local framework = _G._detalhes:GetFramework()
		local SharedMedia = LibStub:GetLibrary("LibSharedMedia-3.0")
		local CONST_DBTYPE_DEATH = "deaths"
		local CONST_DBTYPE_ENDURANCE = "endurance"
		
		local debugmode = false
	
	--> main frame
	
		f:SetFrameStrata ("MEDIUM")
		f:SetPoint ("center", UIParent, "center")
		
		f:SetWidth (845)
		f:SetHeight (428)
		f:EnableMouse (true)
		f:SetResizable (false)
		f:SetMovable (true)
		f:SetScript ("OnMouseDown", 
						function (self, botao)
							if (botao == "LeftButton") then
								if (self.isMoving) then
									return
								end
								self:StartMoving()
								self.isMoving = true
							elseif (botao == "RightButton") then
								if (self.isMoving) then
									return
								end
								DeathGraphs:CloseWindow()
							end
						end)
						
		f:SetScript ("OnMouseUp", 
						function (self)
							if (self.isMoving) then
								self:StopMovingOrSizing()
								self.isMoving = false
							end
						end)
		
		--f:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
		
		f:SetBackdrop ({bgFile = [[Interface\ACHIEVEMENTFRAME\UI-Achievement-Parchment-Horizontal]], tile = true, tileSize = 830,
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 32,
			insets = {left = 5, right = 5, top = 5, bottom = 5}})
		f:SetBackdropColor (0, 0, 0, .4)
		
		local title = framework:NewLabel (f, nil, "$parentTitle", nil, "A.D.L.", nil, 20, "yellow")
		title:SetPoint (12, -13)
		DeathGraphs:SetFontOutline (title, true)

		local bottom_texture = framework:NewImage (f, nil, 814, 25, "background", nil, nil, "$parentBottomTexture")
		bottom_texture:SetTexture (0, 0, 0, .6)
		bottom_texture:SetPoint ("bottomleft", f, "bottomleft", 8, 7)
		
		local c = CreateFrame ("Button", nil, f, "UIPanelCloseButton")
		c:SetWidth (32)
		c:SetHeight (32)
		c:SetPoint ("TOPRIGHT",  f, "TOPRIGHT", -3, -8)
		c:SetFrameLevel (f:GetFrameLevel()+1)
		c:SetAlpha (0.5)
		
		--under development warning
		local label = framework:NewLabel (f, _, "$parentPluginWarningLabel", "PluginWarningLabel", "Under Development", "GameFontNormal")
		local image = framework:NewImage (f, [[Interface\DialogFrame\UI-Dialog-Icon-AlertNew]])
		label:SetPoint ("topright", f, "topright", -520, -20)
		label:SetJustifyH ("left")
		label:SetWidth (160)
		image:SetPoint ("right", label, "left", -7, 0)	
		image:SetSize (32, 32)
	
	--> boss scroll
		local boss_refresh = function (self)
			
			local amount = 0
			local numeric = {}
			
			for hash, t in pairs (DeathGraphs.deaths_database) do 
				amount = amount+1
				tinsert (numeric, t)
			end
			
			FauxScrollFrame_Update (self, amount, 6, 61)
			
			local offset = FauxScrollFrame_GetOffset (self)
			
			for bar_index = 1, 6 do
				local data = numeric [bar_index + offset]
				local button = self.buttons [bar_index]
				
				if (data) then
					local id = data.id
					local name = data.name
					local diff = data.diff
					local hash = data.hash

					if (data.boss_table) then
						local l, r, t, b, texture = _detalhes:GetBossIcon (data.boss_table.mapid, data.boss_table.index)
						button.icon:SetTexture (texture)
						button.icon:SetTexCoord (l, r, t, b)
					end
					button.name:SetText (name)
					button.desc:SetText (data.boss_table and data.boss_table.diff_string or "unknown diff")
					
					button.boss = hash
					button:Show()
				else
					button:Hide()
				end
			end

		end
		
		local boss_scroll = CreateFrame ("scrollframe", "DeathGraphsBossScroll", f, "FauxScrollFrameTemplate")
		boss_scroll:SetScript ("OnVerticalScroll", function (self, offset) FauxScrollFrame_OnVerticalScroll (self, offset, 61, boss_refresh) end)
		boss_scroll:SetPoint ("topleft", f, "topleft", 10, -50)
		boss_scroll:SetSize (142, 338)
		boss_scroll:SetBackdrop ({bgFile = "Interface\\AddOns\\Details\\images\\background", tile = true, tileSize = 16,
		edgeFile=[[Interface\AddOns\Details\images\border_1]], edgeSize=16,
		insets = {left = 0, right = 0, top = 0, bottom = 0}})
		boss_scroll:SetBackdropBorderColor (.8, .8, .8, 1)
		boss_scroll:SetBackdropColor (.1, .1, .1, .2)
		
		boss_scroll.buttons = {}
		
		local boss_button_on_click = function (param1, param2, self)
			--> carrega lista de jogadores para este boss
			DeathGraphs.db.last_boss = self.MyObject.boss
			if (DeathGraphs.db.showing_type == 1) then
				DeathGraphs:RefreshPlayerScroll()
				
			elseif (DeathGraphs.db.showing_type == 2) then
				DeathGraphs:ShowEndurance (DeathGraphs.db.last_boss)
			end
		end
	
		local border_coords = {144/256, 219/256, 16/512, 92/512}
		for i = 1, 6 do
			local button = framework:NewButton (f, nil, "$parentBossButton" .. i, "BossButton" .. i, 120, 60, boss_button_on_click, 1)
			button:SetPoint ("topleft", f, "topleft", 10, i*51*-1)
			
			local avatar = framework:NewImage (button, nil, 40, 40, "artwork", nil, "icon")
			avatar:SetPoint ("left", button, "left")
			local border = framework:NewImage (button, [[Interface\TALENTFRAME\talent-main]], 44, 44, "overlay", border_coords)
			border:SetPoint ("center", avatar, "center")
			
			local name = framework:NewLabel (button, nil, nil, "name", "", "GameFontHighlightSmall")
			DeathGraphs:SetFontOutline (name, true)
			
			local desc = framework:NewLabel (button, nil, nil, "desc", "", "GameFontHighlightSmall", 9, "orange")
			
			name:SetPoint ("left", avatar, "right", 4, 6)
			desc:SetPoint ("topleft", name, "bottomleft", 2, -3)

			tinsert (boss_scroll.buttons, button)
		end
		
		function DeathGraphs:RefreshBossScroll()
			boss_refresh (boss_scroll)
		end
		
	--> player scroll
		local player_refresh = function (self)
			--> pega a lista de player
			local boss_hash = DeathGraphs.db.last_boss
			local players = DeathGraphs.deaths_database [boss_hash]

			if (debugmode) then
				print ("player refresh (boss_hash, players):", boss_hash, players)
			end
			
			if (players) then
				local players_list = players.player_db
				
				local amount = 0
				local numeric = {}
				
				for playername, t in pairs (players_list) do 
					amount = amount+1
					tinsert (numeric, t)
				end
				table.sort (numeric, function(t1, t2) return t1.name < t2.name end)
				
				FauxScrollFrame_Update (self, amount, 16, 21)
				
				local offset = FauxScrollFrame_GetOffset (self)
				
				for bar_index = 1, 16 do
					local data = numeric [bar_index + offset]
					local button = self.buttons [bar_index]
					if (data) then
						button:SetText (DeathGraphs:GetOnlyName (data.name))
						if (data.class) then
							local r, g, b = DeathGraphs:GetClassColor (data.class)
							button.text_overlay:SetTextColor (r, g, b)
							local _, l, r, t, b = DeathGraphs:GetClassIcon (data.class)
							button:SetIcon ("Interface\\AddOns\\Details_DeathGraphs\\class_icons", 16, 16, "overlay", {l, r, t, b})
						else
							button.text_overlay:SetTextColor (1, 1, 1)
							button:SetIcon ("Interface\\AddOns\\Details_DeathGraphs\\class_icons", 16, 16, "overlay", {0.75, 1, 0.5, 0.75})
						end
						button.player_table = data
						button.player_name = data.name


						button:Show()
					else
						button:Hide()
					end
				end
			else
				for bar_index = 1, 16 do
					local button = self.buttons [bar_index]
					button:Hide()
				end
			end
		end
		
		local player_scroll = CreateFrame ("scrollframe", "DeathGraphsPlayerScroll", f, "FauxScrollFrameTemplate")
		player_scroll:SetScript ("OnVerticalScroll", function (self, offset) FauxScrollFrame_OnVerticalScroll (self, offset, 20, player_refresh) end)
		player_scroll:SetPoint ("topleft", f, "topleft", 178, -50)
		player_scroll:SetSize (100, 338)
		player_scroll:SetFrameLevel (f:GetFrameLevel()+2)
		
		local player_bg_frame = CreateFrame ("frame", nil, f)
		player_bg_frame:SetPoint ("topleft", player_scroll, "topleft")
		player_bg_frame:SetPoint ("bottomright", player_scroll, "bottomright", -2, 0)
		player_bg_frame:SetBackdrop ({bgFile = "Interface\\AddOns\\Details\\images\\background", tile = true, tileSize = 16,
		edgeFile=[[Interface\AddOns\Details\images\border_1]], edgeSize=16,
		insets = {left = 0, right = 0, top = 0, bottom = 0}})
		player_bg_frame:SetBackdropColor (.1, .1, .1, .2)
		player_bg_frame:SetBackdropBorderColor (.8, .8, .8, 1)
		player_bg_frame:SetFrameLevel (f:GetFrameLevel()+1)
		
		player_scroll:SetScript ("OnHide", function()
			for i = 1, 16 do
				player_scroll.buttons[i]:Hide()
			end
		end)
		
		player_scroll.buttons = {}
		
		local player_button_on_click = function (param1, param2, self)
			--> carrega lista de segmentos para este jogador
			DeathGraphs.db.last_player = self.MyObject.player_name
			DeathGraphs:RefreshSegmentScroll()
		end
	
		for i = 1, 16 do
			local button = framework:NewButton (f, nil, "$parentPlayerButton" .. i, "PlayerButton" .. i, 120, 20, player_button_on_click, 1, nil, nil, "Player " .. i)
			button:SetPoint ("topleft", f, "topleft", 180, (i*21*-1) - 30)
			button.textalign = "left"
			button.textsize = 10
			tinsert (player_scroll.buttons, button)
			button:Hide()
		end
		
		function DeathGraphs:RefreshPlayerScroll()
			player_refresh (player_scroll)
		end
	
	--> segment scroll
		local segment_refresh = function (self)
			--> pega a lista de segmentos
			
			local boss_hash = DeathGraphs.db.last_boss
			local player_name = DeathGraphs.db.last_player
			
			if (debugmode) then
				print ("refresh segments:", boss_hash, player_name)
			end
			
			if (player_name) then
			
				local player_container = DeathGraphs.deaths_database [boss_hash] and DeathGraphs.deaths_database [boss_hash].player_db [player_name]
				
				if (debugmode) then
					print ("refresh segments:", player_container)
				end
				
				if (player_container) then
					local amount = #player_container.deaths
					
					FauxScrollFrame_Update (self, amount, 16, 21)
					
					local offset = FauxScrollFrame_GetOffset (self)
					
					for bar_index = 1, 16 do
						local data = player_container.deaths [bar_index + offset]
						local button = self.buttons [bar_index]
						if (data) then
							button:SetText ("#" .. bar_index + offset)
							button.death_table = data
							button.index = bar_index + offset
							button:Show()
						else
							button:Hide()
						end
					end
				else
					for bar_index = 1, 16 do
						local button = self.buttons [bar_index]
						button:Hide()
					end
				end
			else
				for bar_index = 1, 16 do
					local button = self.buttons [bar_index]
					button:Hide()
				end
			end
			
		end
		
		local segments_scroll = CreateFrame ("scrollframe", "DeathGraphsSegmentScroll", f, "FauxScrollFrameTemplate")
		segments_scroll:SetScript ("OnVerticalScroll", function (self, offset) FauxScrollFrame_OnVerticalScroll (self, offset, 20, segment_refresh) end)
		segments_scroll:SetPoint ("topleft", f, "topleft", 310, -50)
		segments_scroll:SetSize (35, 338)
		segments_scroll:SetFrameLevel (f:GetFrameLevel()+2)
		
		local segments_bg_frame = CreateFrame ("frame", nil, f)
		segments_bg_frame:SetPoint ("topleft", segments_scroll, "topleft")
		segments_bg_frame:SetPoint ("bottomright", segments_scroll, "bottomright", -5, 0)
		segments_bg_frame:SetBackdrop ({bgFile = "Interface\\AddOns\\Details\\images\\background", tile = true, tileSize = 16,
		edgeFile=[[Interface\AddOns\Details\images\border_1]], edgeSize=16,
		insets = {left = 0, right = 0, top = 0, bottom = 0}})
		segments_bg_frame:SetBackdropColor (.1, .1, .1, .2)
		segments_bg_frame:SetBackdropBorderColor (.8, .8, .8, 1)
		segments_bg_frame:SetFrameLevel (f:GetFrameLevel()+1)
		
		segments_scroll:SetScript ("OnHide", function()
			for i = 1, 16 do
				segments_scroll.buttons[i]:Hide()
			end
		end)
		
		segments_scroll.buttons = {}
		
		local segment_button_on_click = function (param1, param2, self)
			--> mostra o grfico para este segmento
			if (debugmode) then
				print ("on click segment:", self.MyObject.death_table, self.MyObject.index, DeathGraphs.db.last_boss)
			end
			DeathGraphs.db.last_segment = self.MyObject.index
			
			local death_table = DeathGraphs:GetBossTable (DeathGraphs.db.last_boss , nil, CONST_DBTYPE_DEATH)
			local player_table = DeathGraphs:GetPlayerTable (death_table, DeathGraphs.db.last_player)
			
			DeathGraphs:ShowGraphicForDeath (player_table.deaths [DeathGraphs.db.last_segment])
		end
	
		for i = 1, 16 do
			local button = framework:NewButton (f, nil, "$parentSegmentButton" .. i, "SegmentButton" .. i, 20, 20, segment_button_on_click, 1, nil, nil, "Segment " .. i)
			button.width = 22
			button:SetPoint ("topleft", f, "topleft", 310, (i*21*-1) - 30)
			button.textalign = "left"
			--button:InstallCustomTexture()
			tinsert (segments_scroll.buttons, button)
			button:Hide()
		end
		
		function DeathGraphs:RefreshSegmentScroll()
			segment_refresh (segments_scroll)
		end
		
	--> endurance box
		local endurance_frame = CreateFrame ("frame", "DeathGraphsEnduranceFrame", f)
		endurance_frame:SetFrameStrata ("MEDIUM")
		endurance_frame:SetFrameLevel (f:GetFrameLevel()+5)
		endurance_frame:SetPoint ("topright", f, "topright", -10, -10)
		
		endurance_frame:SetWidth (518)
		endurance_frame:SetHeight (385)
		endurance_frame:EnableMouse (true)
		endurance_frame:SetResizable (false)
		endurance_frame:SetMovable (true)
		endurance_frame:SetScript ("OnMouseDown", 
						function (self, botao)
							if (botao == "LeftButton") then
								if (f.isMoving) then
									return
								end
								f:StartMoving()
								f.isMoving = true
							elseif (botao == "RightButton") then
								if (f.isMoving) then
									return
								end
								DeathGraphs:CloseWindow()
							end
						end)
						
		endurance_frame:SetScript ("OnMouseUp", 
						function (self)
							if (f.isMoving) then
								f:StopMovingOrSizing()
								f.isMoving = false
							end
						end)
		
		endurance_frame:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16})
		endurance_frame:SetBackdropColor (.1, .1, .1, .8)
		
		endurance_frame.labels = {}
		endurance_frame:Hide()
		
		endurance_frame.x = 10
		endurance_frame.y = -10
		
		function endurance_frame:Clear()
			for _, label in ipairs (self.labels) do 
				label.points:Hide()
				label.name:Hide()
			end
		end
		
		function endurance_frame:SetPlayer (index, player_name, player_class, points)
			local label = self.labels [index]
			
			if (not label) then
				local str1 = framework:NewLabel (endurance_frame, nil, "$parentLabel1" .. index, "label" .. index, "", "GameFontHighlightSmall", 11)
				local str2 = framework:NewLabel (endurance_frame, nil, "$parentLabel2" .. index, "label" .. index, "", "GameFontHighlightSmall", 11)
				str2:SetWidth (120)
				str2:SetHeight (16)
				
				str1:SetPoint (self.x, self.y)
				str2:SetPoint ("left", str1, "right", 2, 0)
				
				endurance_frame.y = endurance_frame.y - 16
				if (endurance_frame.y < -350) then
					endurance_frame.y = -10
					endurance_frame.x = endurance_frame.x + 160
				end
				self.labels [index] = {points = str1, name = str2}
				label = self.labels [index]
			end
			
			label.points.text = points
			label.name.text = player_name
			
			local r, g, b = DeathGraphs:GetClassColor (player_class)
			label.name:SetTextColor (r, g, b)
			
			label.points:Show()
			label.name:Show()
		end
	
		function endurance_frame:Cancel()
			endurance_frame:Hide()
			DeathGraphs.db.showing_type = 1
			return
		end
	
		function DeathGraphs:ShowEndurance (boss)
		
			--> get boss table
			boss = boss or DeathGraphs.showing_endurance or DeathGraphs.db.last_boss
			if (debugmode) then
				print (":ShowEndurance", boss)
			end
			if (not boss) then
				return endurance_frame:Cancel()
			end
			local boss_table = DeathGraphs.endurance_database [boss]
			if (debugmode) then
				print (":ShowEndurance", boss_table)
			end
			if (not boss_table) then
				return endurance_frame:Cancel()
			end
			
			player_scroll:Show()
			player_scroll:Hide()
			segments_scroll:Show()
			segments_scroll:Hide()
			
			DeathGraphs.graphic_frame:Hide()
			
			--> refresh
			DeathGraphs.db.showing_type = 2
			endurance_frame:Clear()
			
			local sorted = {}
			for player_name, t in pairs (boss_table.player_db) do
				tinsert (sorted, {player_name, t.class, t.points})
			end
			table.sort (sorted, DeathGraphs.Sort3)
			
			for index, t in ipairs (sorted) do
				endurance_frame:SetPlayer (index, t[1], t[2], t[3])
			end

			--> show
			endurance_frame:Show()
		end
		
		function DeathGraphs:HideEndurance()
			DeathGraphs.db.showing_type = 1
			endurance_frame:Hide()
			player_scroll:Show()
			segments_scroll:Show()
			
			DeathGraphs:RefreshPlayerScroll()
			DeathGraphs:RefreshSegmentScroll()
			
			if (DeathGraphs.db.last_segment) then
				DeathGraphs.graphic_frame:Show()
			end
		end
		
	--> bottom menu bar
	
	--> dropdown select type
		local select_type_label = framework:NewLabel (f, nil, "$parentTypeLabel", nil, "Showing:")
	
		local OnSelectType = function (_, _, type)
			--> mostrar ou esconder o box de endurance
			if (type == 2) then
				DeathGraphs:ShowEndurance()
			elseif (type == 1) then
				DeathGraphs:HideEndurance()
			end
			
		end
		
		local type_menu = {
			{value = 1, label = "Deaths", onclick = OnSelectType, icon = [[Interface\GROUPFRAME\UI-GROUP-MAINASSISTICON]], desc = "Show players deaths."},
			{value = 2, label = "Endurance", onclick = OnSelectType, icon = [[Interface\GROUPFRAME\UI-GROUP-MAINASSISTICON]], desc = "Show players endurance."},
		}

		local select_type_dropdown = framework:NewDropDown (f, nil, "$parentSegmentDropdown", nil, 150, 20, function() return type_menu end, DeathGraphs.db.showing_type)
		select_type_label:SetPoint ("bottomleft", f, "bottomleft", 15, 14)
		select_type_dropdown:SetPoint ("left", select_type_label, "right", 2, 0)
	
	--> refresh on open
		function DeathGraphs:Refresh()
			
			DeathGraphs:RefreshBossScroll()
			
			if (DeathGraphs.db.showing_type == 2) then --endurance
				DeathGraphs:ShowEndurance()
			end
			
			if (DeathGraphs.db.showing_type == 1) then --else or nothing to show on endurance
			
				local last_boss = DeathGraphs.db.last_boss
				
				if (last_boss) then
					--> check if the last table exists
					if (DeathGraphs.deaths_database [last_boss]) then
						local last_player = DeathGraphs.db.last_player
						local last_segment = DeathGraphs.db.last_segment
					else
						local last_encounter = DeathGraphs.last_encounter_hash
						if (last_encounter and DeathGraphs.deaths_database [last_encounter]) then
							DeathGraphs.db.last_boss = DeathGraphs.last_encounter_hash
						else
							DeathGraphs.db.last_boss = false
						end

						DeathGraphs.db.last_player = false
						DeathGraphs.db.last_segment = false
					end
				else
					local last_encounter = DeathGraphs.last_encounter_hash
					if (last_encounter and DeathGraphs.deaths_database [last_encounter]) then
						DeathGraphs.db.last_boss = DeathGraphs.last_encounter_hash
					else
						DeathGraphs.db.last_boss = false
					end

					DeathGraphs.db.last_player = false
					DeathGraphs.db.last_segment = false
				end

				DeathGraphs:RefreshBossScroll()
				DeathGraphs:RefreshPlayerScroll()
				DeathGraphs:RefreshSegmentScroll()

			end
		end
		
	--> graphic
	
		local log
		local loglines = {}
		local linhas = {}
		local gradeframes = {}
		local gradelinhas = {}
		
		local gballs = {}
		
		local GetSpellInfo = _detalhes.getspellinfo
		local flag_logmouseover = false
	
		local gframe = CreateFrame ("frame", nil, f)
		gframe:SetSize (475, 160)
		gframe:SetPoint ("topleft", f, "topleft", 369, -50)
		gframe.CustomLine = [[Interface\AddOns\Details\Libs\LibGraph-2.0\line]]
		DeathGraphs.graphic_frame = gframe
		
		local g = LibStub:GetLibrary ("LibGraph-2.0")
		
		--> graphic lines on enter and leave
		local on_enter = function (self)
		
			self:SetBackdropColor (.1, .1, .1, 0)
			local ball = gballs [self.id]
			ball:SetBlendMode ("ADD")
			local line = ball.line
			line:SetBlendMode ("ADD")
			
			if (self.data [2] ~= 0) then
				GameCooltip:Reset()
				
				GameCooltip:SetOption ("ButtonsYMod", 0)
				GameCooltip:SetOption ("YSpacingMod", -5)
				GameCooltip:SetOption ("IgnoreButtonAutoHeight", true)
				GameCooltip:SetColor (1, 0.5, 0.5, 0.5, 0.5)
				
				local spellname, _, spellicon = GetSpellInfo (self.data [2])
				
				GameCooltip:AddLine (spellname, nil, 1, "orange", nil, 12, SharedMedia:Fetch ("font", "Friz Quadrata TT"))
				GameCooltip:AddIcon (spellicon, 1, 1, 16, 16)
				
				--> death parser
				if (type (self.data [1]) == "boolean") then --> damage or heal
					if (self.data [1]) then
						GameCooltip:AddLine ("-" .. DeathGraphs:comma_value (self.data [3])) --> damage
						if (self.data [9]) then
							GameCooltip:AddLine ("Friendly Fire")
						end
						GameCooltip:AddLine ("School: " .. self.data [8])
					else
						GameCooltip:AddLine ("+" .. DeathGraphs:comma_value (self.data [3]))
					end
					
				elseif (type (self.data [1]) == "number") then
					if (self.data [1] == 1) then --cooldown
						GameCooltip:AddLine ("Cooldown")
					elseif (self.data [1] == 2) then --battle ress
						GameCooltip:AddLine ("Battleress")
					end
				end
				
				GameCooltip:AddLine ("Source: " .. self.data [6])
			
				GameCooltip:SetOwner (ball.tooltip_anchor, "bottomleft", "topright")
				GameCooltip:Show()
			end
			
		end
		local on_leave = function (self)
			self:SetBackdropColor (.1, .1, .1, .4)
			local ball = gballs [self.id]
			ball:SetBlendMode ("BLEND")
			local line = ball.line
			line:SetBlendMode ("BLEND")
			GameCooltip:Hide()
		end
		
		--> graphic lines
		for i = 1, 16 do
			linhas [i] = g:DrawLine (gframe, 400, 500, 600, 700, 20, {1, 1, 1, 1}, "artwork")
			
			local f = CreateFrame ("frame", nil, gframe)
			f:SetPoint ("left", gframe, "left", (i-1)*29, 0)
			f:SetSize (29, 160)
			gradeframes [i] = f
			f.id = i
			f:SetScript ("OnEnter", on_enter)
			f:SetScript ("OnLeave", on_leave)
			f:SetBackdrop ({bgFile = "Interface\\AddOns\\Details\\images\\background", tile = true, tileSize = 16,
			insets = {left = 0, right = 0, top = 0, bottom = 0}})
			f:SetBackdropColor (.1, .1, .1, .4)
			
			local t = gframe:CreateTexture (nil, "background")
			t:SetSize (1, 160)
			t:SetPoint ("left", gframe, "left", i*29, 0)
			t:SetTexture (1, 1, 1, .1)
			gradelinhas [i] = t
			
			local b = f:CreateTexture (nil, "overlay")
			b:SetTexture ([[Interface\COMMON\Indicator-Yellow]])
			b:SetSize (16, 16)
			local anchor =CreateFrame ("frame", nil, f)
			anchor:SetAllPoints (b)
			b.tooltip_anchor = anchor
			gballs [i] = b
		end
		
		function gframe:ShowGrid()
			for _, frame in ipairs (gradeframes) do 
				frame:Show()
			end
			for _, line in ipairs (gradelinhas) do 
				line:Show()
			end
			for _, bola in ipairs (gballs) do 
				bola:Show()
			end
			gframe.timeline:Show()
		end
		function gframe:HideGrid()
			for _, frame in ipairs (gradeframes) do 
				frame:Hide()
			end
			for _, line in ipairs (gradelinhas) do 
				line:Hide()
			end
			for _, bola in ipairs (gballs) do 
				bola:Hide()
			end
			gframe.timeline:Hide()
		end

		function gframe:Reset()
			for i = #gframe.GraphLib_Lines_Used, 1, -1 do
				local line = tremove (gframe.GraphLib_Lines_Used)
				tinsert (gframe.GraphLib_Lines, line)
				line:Hide()
			end
		end
		
		--> timeline
		local timeline_bg = CreateFrame ("frame", nil, gframe)
		gframe.timeline = timeline_bg
		timeline_bg:SetPoint ("topleft", gframe, "bottomleft", 0, -1)
		timeline_bg:SetPoint ("topright", gframe, "bottomright", -11, -1)
		timeline_bg:SetHeight (20)
		timeline_bg:SetBackdrop ({bgFile = "Interface\\AddOns\\Details\\images\\background", tile = true, tileSize = 16,
			insets = {left = 0, right = 0, top = 0, bottom = 0}})
		timeline_bg:SetBackdropColor (.1, .1, .1, .3)
		timeline_bg.labels = {}
		for i = 1, 16 do 
			local l = timeline_bg:CreateFontString (nil, "overlay", "GameFontNormal")
			DeathGraphs:SetFontSize (l, 9)
			DeathGraphs:SetFontColor (l, "silver")
			l:SetPoint ("left", timeline_bg, "left", (i-1) * 29, 0)
			timeline_bg.labels [i] = l
		end

		local red = {.9, .1, .1, 1}
		local green = {.1, .9, .1, 1}
		local white = {1, 1, 1, 1}
		local gray = {.5, .5, .5, 1}
		local orange = {1, .6, 0, 1}
		
		function DeathGraphs:ShowGraphicForDeath (data)
			
			gframe:Reset()
			gframe:ShowGrid()
		
			if (not data) then
				return
			end
		
			local timeline = data [1]
			local max_health = data[4]

			if (#timeline < 16) then
				while (#timeline < 16) do
					table.insert (timeline, 1, {false, 0, 0, data[6], max_health, "-1"})
				end
			end
			
			log = timeline
			
			local h = gframe:GetHeight()/100

			local o = 1
			local lastlife = 156

			--for i = 16, 1, -1 do
			for i = 1, 16, 1 do
				local t = timeline [i]
				if (type (t) == "table") then
				
					--> death parser
					
					local evtype = t [1] --event type
					local spellid = t [2] --spellid
					local amount = t [3] --amount healed or damaged
					local time = t [4] --time
					local life = t [5] --health
					local source = t [6] --source

					local plife = life / max_health * 100
					if (plife > 98) then
						plife = 98
					end
					plife = plife*h
					
					local line
					
					if (source == "-1") then
						--> neutral line
						line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, gray, "overlay")
						
					elseif (type (evtype) == "boolean") then
						--> damage or heal
						if (evtype) then
							--> damage
							if (t [9]) then
								--> friendly fire
								line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, orange, "overlay")
							else
								--> normal damage
								line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, red, "overlay")
							end
						elseif (not evtype) then
							--> heal
							line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, green, "overlay")
						end
						
					elseif (type (evtype) == "number") then
						--> cooldown / bres / last cooldown
						if (evtype == 1) then
							--> cooldown
							line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, white, "overlay")
							
						elseif (evtype == 2 and not battleress) then
							--> battle ress
							local p = plife
							local next = timeline [i+1]
							if (next) then
								local plife = next [5] / max_health * 100
								if (plife > 98) then
									plife = 98
								end
								p = plife*h
							end
							line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, p, 50, white, "overlay")
							plife = p
							
						elseif (evtype == 3) then
							--> last cooldown used
							line = g:DrawLine (gframe, (o-1)*29, lastlife, o*29, plife, 50, gray, "overlay")
						end
					end

					gballs [o]:SetPoint ("bottomleft", gframe, "bottomleft", (o*29)-8, plife-8)
					gballs [o].line = line
					
					local clock = data[6] - time
					if (type (evtype) == "number" and evtype == 2) then
						if (clock <= 100) then
							timeline_bg.labels [o]:SetText (math.floor (clock))
						else
							timeline_bg.labels [o]:SetText (string.format ("%.1f", clock))
						end
					else
						timeline_bg.labels [o]:SetText ("-" .. string.format ("%.1f", clock))
					end
					
					local frame = gradeframes [o]
					frame.data = t
					
					lastlife = plife
					o = o + 1
				end
			end

		end
		
		--gframe:SetScript ("OnShow", function() gframe.timeline:Show() end)
		--gframe:SetScript ("OnHide", function() gframe.timeline:Hide() end)
		
		gframe:Reset()
		gframe:HideGrid()		
		
	end
end